﻿#region Revision info

/*
 * $Author: wulf_ $
 * $Date: 2013-09-20 23:55:55 +1000 (Fri, 20 Sep 2013) $
 * $ID$
 * $Revision: 232 $
 * $URL: https://subversion.assembla.com/svn/oracle/trunk/Oracle/Classes/RotationBase.SpellBook.cs $
 * $LastChangedBy: wulf_ $
 * $ChangesMade$
 */

#endregion Revision info

using System.Collections.Generic;

namespace Oracle.Classes
{
    partial class RotationBase
    {

        #region Common

        
        internal static readonly HashSet<int> Lucidity = new HashSet<int>
        {
            137331, // Monks
            137247, // Druids
            137288, // Paladins
            137323, // Priests
            137326, // Shamans
        };

        internal const int MassResurrection = 83968;

        #endregion

        #region Monk

        internal const int SoothingMist = 115175,
                           ThunderFocusTea = 116680,
                           Uplift = 116670,
                           ChiWave = 115098,
                           ManaTea = 115294,
                           SurgingMist = 116694,
                           RushingJadeWind = 116847,
                           RenewingMist = 115151,
                           VitalMists = 118674,
                           ChiBurst = 123986,
                           ChiBrew = 115399,
                           Revival = 115310,
                           InvokeXuentheWhiteTiger = 123904,
                           LifeCocoon = 116849,
                           HealingSphere = 115460,
                           StanceoftheFierceTiger = 103985,
                           EnvelopingMist = 124682;

        internal static readonly HashSet<int> RenewingMists = new HashSet<int>
        {
            119611, // Glyph
            115151, // Normal
            119647,
            119607, // the spread - use this to track. 114908
        };

        #endregion Monk

        #region Priest

        internal static readonly HashSet<int> SpiritShells = new HashSet<int>
        {
            // 109964, our aura we gain by casting the spell.
            114908 // the aura applied by PoH from us.
        };

        internal const int Psyfiend = 108921,
                            DominateMind = 605,
                            AngelicFeather = 121536,
                            PowerWordSolace = 129250,
                            DespareatePrayer = 19236,
                            SpectralGuise = 112833,
                            PowerInfusion = 10060,
                            WeakenedSoul = 6788,
                            PrayerofMendingbuff = 41635,
                            Cascade = 121135,
                            DivineStar = 110744,
                            Halo = 120517,
                            Archangel = 81700,
                            BindingHeal = 32546,
                            DispelMagic = 528,
                            Fade = 586,
                            FearWard = 6346,
                            FlashHeal = 2061,
                            GreaterHeal = 2060,
                            Heal = 2050,
                            HolyFire = 14914,
                            HymnOfHope = 64901,
                            InnerFire = 588,
                            InnerFocus = 89485,
                            InnerWill = 73413,
                            LeapOfFaith = 73325,
                            Levitate = 1706,
                            MassDispel = 32375,
                            MindSear = 48045,
                            MindVision = 2096,
                            Shadowfiend = 34433,
                            Mindbender = 123040,
                            PainSuppression = 33206,
                            Penance = 47540,
                            PowerWordBarrier = 62618,
                            PowerWordFortitude = 21562,
                            PowerWordShield = 17,
                            PrayerOfHealing = 596,
                            PrayerOfMending = 33076, 
                            PsychicScream = 8122,
                            Purify = 527,
                            Renew = 139,
                            Resurrection = 2006,
                            ShackleUndead = 9484,
                            ShadowWordDeath = 32379,
                            ShadowWordPain = 589,
                            Smite = 585,
                            SpiritShell = 109964,
                            VoidTendrils = 108920,
                            CircleOfHealing = 34861,
                            DivineHymn = 64843,
                            GuardianSpirit = 47788,
                            HolyWordChastise = 88625,
                            HolyWordSanctuary = 88685,
                            HolyWordSerenity = 88684,
                            Lightwell = 724, 
                            Lightspring = 126135,
                            VoidShift = 108968,
                            DevouringPlague = 2944,
                            Dispersion = 47585,
                            MindBlast = 8092,
                            MindFlay = 15407,
                            MindSpike = 73510,
                            PsychicHorror = 64044,
                            Shadowform = 15473,
                            Silence = 15487,
                            VampiricEmbrace = 15286,
                            VampiricTouch = 34914;

        #endregion Priest

        #region DeathKnight

        internal const int PlagueLeech = 123693,
                            BloodPlague = 55078,
                            UnholyBlight = 115989,
                            Lichborne = 49039,
                            AntiMagicZone = 51052,
                            DeathsAdvance = 96268,
                            Asphyxiate = 108194,
                            DeathPact = 48743,
                            DeathSiphon = 108196,
                            Conversion = 119975,
                            BloodTap = 45529,
                            GorefiendsGrasp = 108199,
                            RemorselessWinter = 108200,
                            DesecratedGround = 108201,
                            DeathKnightSymbiosis = 110498,
                            AntiMagicShell = 48707,
                            ArmyoftheDead = 42650,
                            BloodBoil = 48721,
                            BloodPresence = 48263,
                            BoneShield = 49222,
                            ChainsofIce = 45524,
                            ControlUndead = 111673,
                            DancingRuneWeapon = 49028,
                            DarkCommand = 56222,
                            DarkSimulacrum = 77606,
                            DeathandDecay = 43265,
                            DeathCoil = 47541,
                            DeathGate = 50977,
                            DeathGrip = 49576,
                            DeathStrike = 49998,
                            EmpowerRuneWeapon = 47568,
                            FrostPresence = 48266,
                            BloodStrike = 45902,
                            HornofWinter = 57330,
                            IceboundFortitude = 48792,
                            IcyTouch = 45477,
                            MindFreeze = 47528,
                            NecroticStrike = 73975,
                            Outbreak = 77575,
                            PathofFrost = 3714,
                            Pestilence = 50842,
                            PlagueStrike = 45462,
                            RaiseAlly = 61999,
                            RaiseDead = 46584,
                            RuneStrike = 56815,
                            RuneTap = 48982,
                            Runeforging = 53428,
                            Strangulate = 47476,
                            UnholyPresence = 48265,
                            VampiricBlood = 55233,
                            FrostStrike = 49143,
                            HowlingBlast = 49184,
                            Obliterate = 49020,
                            PillarofFrost = 51271,
                            SoulReaper = 130736,
                            UnholyAura = 55610,
                            DarkTransformation = 63560,
                            FesteringStrike = 85948,
                            ScourgeStrike = 55090,
                            SummonGargoyle = 49206,
                            UnholyFrenzy = 49016,
                            PredatorySwiftness = 16974,
                            BearHug = 102795,
                            Enrage = 5229,
                            SavageDefense = 62606;

        #endregion DeathKnight

        #region Druid

        internal const int DisplacerBeast = 102280,
                           SageMender = 144871, // druid Tier 16 Support
                           WildCharge = 102401,
                           SouloftheForest = 114108,
                           NaturesSwiftness = 132158,
                           Renewal = 108238,
                           CenarionWard = 102351,
                           MassEntanglement = 102359,
                           Typhoon = 132469,
                           Incarnation = 106731,
                           ForceOfNature = 102693, //106737 .. 102693
                           DisorientingRoar = 99,
                           UrsolsVortex = 102793,
                           MightyBash = 5211,
                           HeartOfTheWild = 108288,
                           Harmony = 100977,
                           Clearcasting = 16870,
                           NaturesVigil = 124974,
                           AquaticForm = 1066,
                           Barkskin = 22812,
                           BearForm = 5487,
                           CatForm = 768,
                           Cyclone = 33786,
                           Dash = 1850,
                           EntanglingRoots = 339,
                           FaerieFire = 770,
                           FerociousBite = 22568,
                           FrenziedRegeneration = 22842,
                           Growl = 6795,
                           Genesis = 145518,
                           HealingTouch = 5185,
                           Hibernate = 2637,
                           Hurricane = 16914,
                           AstralStorm = 106996,
                           Innervate = 29166,
                           Ironbark = 102342,
                           Lacerate = 33745,
                           Lifebloom = 33763,
                           Maim = 22570,
                           Mangle = 33917,
                           MarkoftheWild = 1126,
                           Maul = 6807,
                           MightofUrsoc = 106922,
                           Moonfire = 8921,
                           NaturesCure = 88423,
                           NaturesGrasp = 16689,
                           Nourish = 50464,
                           T14_4P = 123089,
                           Pounce = 9005,
                           Prowl = 5215,
                           Rake = 1822,
                           Rebirth = 20484,
                           Regrowth = 8936,
                           Rejuvenation = 774,
                           Revive = 50769,
                           Soothe = 2908,
                           StampedingRoar = 106898,
                           SwiftFlightForm = 40120,
                           Swiftmend = 18562,
                           Swipe = 106785,
                           TeleportMoonglade = 18960,
                           TrackHumanoids = 5225,
                           Tranquility = 740,
                           TravelForm = 783,
                           WildGrowth = 48438,
                           WildMushroom = 145205,//88747,
                           WildMushroomBloom = 102791,
                           Wrath = 5176,
                           AstralCommunion = 127663,
                           CelestialAlignment = 112071,
                           MoonkinForm = 24858,
                           RemoveCorruption = 2782,
                           SolarBeam = 78675,
                           Starfall = 48505,
                           Starfire = 2912,
                           Starsurge = 78674,
                           Sunfire = 93402,
                           DruidSymbiosis = 110309,
                           WildMushroomDetonate = 88751,
                           Berserk = 106952,
                           Ravage = 6785,
                           Rip = 1079,
                           SavageRoar = 52610,
                           Shred = 5221,
                           SkullBash = 106839,
                           SurvivalInstincts = 61336,
                           Thrash = 106832,
                           TigersFury = 5217;

        #endregion Druid

        #region Shaman

        internal const int StoneBulwarkTotem = 108270,
                            AstralShift = 108271,
                            EarthgrabTotem = 51485,
                            WindwalkTotem = 108273,
                            CallOfTheElements = 108285,
                            TotemicProjection = 108284,
                            ElementalMastery = 16166,
                            AstralSwiftness = 16188,
                            HealingTideTotem = 108280, // 108280
                            AstralGuidance = 108281,
                            ElementalBlast = 117014,
                            AncestralSpirit = 2008,
                            AstralRecall = 556,
                            BindElemental = 76780,
                            Bloodlust = 2825,
                            ChainHeal = 1064,
                            ChainLightning = 421,
                            EarthShield = 974,
                            EarthShock = 8042,
                            FarSight = 6196,
                            FlameShock = 8050,
                            FrostShock = 8056,
                            GhostWolf = 2645,
                            GreaterHealingWave = 77472,
                            HealingRain = 73920,
                            HealingSurge = 8004,
                            HealingWave = 331,
                            Hex = 51514,
                            LavaBurst = 51505,
                            LightningBolt = 403,
                            LightningShield = 324,
                            PrimalStrike = 73899,
                            Purge = 370,
                            CleanseSpirit = 51886,
                            Riptide = 61295,
                            TidalWaves = 53390,
                            SpiritwalkersGrace = 79206,
                            TotemicRecall = 36936,
                            UnleashElements = 73680,
                            WaterShield = 52127,
                            WaterWalking = 546,
                            WindShear = 57994,
                            CapacitorTotem = 108269,
                            EarthElementalTotem = 2062,
                            EarthbindTotem = 2484,
                            EarthlivingWeapon = 51730,
                            FireElementalTotem = 2894,
                            FlametongueWeapon = 8024,
                            FrostbrandWeapon = 8033,
                            GroundingTotem = 8177,
                            HealingStreamTotem = 5394,
                            MagmaTotem = 8190,
                            ManaTideTotem = 16190,
                            RockbiterWeapon = 8017,
                            SearingTotem = 3599,
                            SpiritLinkTotem = 98008,
                            StormlashTotem = 120668,
                            ShamanSymbiosis = 110504,
                            TremorTotem = 8143,
                            Ascendance = 114049,
                            Earthquake = 61882,
                            Thunderstorm = 51490,
                            FeralSpirit = 51533,
                            FireNova = 1535,
                            LavaLash = 60103,
                            ShamanisticRage = 30823,
                            SpiritWalk = 58875,
                            Stormstrike = 17364;

        #endregion Shaman

        #region Warrior

        internal const int EnragedRegeneration = 55694,
                            ImpendingVictory = 103840,
                            PiercingHowl = 12323,
                            DisruptingShout = 102060,
                            Bladestorm = 46924,
                            DragonRoar = 118000,
                            Safeguard = 114029,
                            Vigilance = 114030,
                            Avatar = 107574,
                            Bloodbath = 12292,
                            StormBolt = 107570,
                            BattleShout = 6673,
                            BattleStance = 2457,
                            BerserkerRage = 18499,
                            BerserkerStance = 2458,
                            Charge = 100,
                            Cleave = 845,
                            CommandingShout = 469,
                            DeadlyCalm = 85730,
                            DefensiveStance = 71,
                            DemoralizingShout = 1160,
                            SunderArmor = 7386,
                            Disarm = 676,
                            Execute = 5308,
                            Hamstring = 1715,
                            HeroicLeap = 6544,
                            HeroicStrike = 78,
                            HeroicThrow = 57755,
                            Intervene = 3411,
                            IntimidatingShout = 5246,
                            LastStand = 12975,
                            MassSpellReflection = 114028,
                            Pummel = 6552,
                            RallyingCry = 97462,
                            Recklessness = 1719,
                            Revenge = 6572,
                            ShatteringThrow = 64382,
                            ShieldBarrier = 112048,
                            ShieldBlock = 2565,
                            ShieldSlam = 23922,
                            ShieldWall = 871,
                            Shockwave = 46968,
                            SpellReflection = 23920,
                            StaggeringShout = 107566,
                            Taunt = 355,
                            Throw = 122475,
                            ThunderClap = 6343,
                            VictoryRush = 34428,
                            WarriorSymbiosis = 110506,
                            ColossusSmash = 86346,
                            DemoralizingBanner = 114203,
                            DiebytheSword = 118038,
                            MockingBanner = 114192,
                            MortalStrike = 12294,
                            Overpower = 7384,
                            SkullBanner = 114207,
                            Slam = 1464,
                            SweepingStrikes = 12328,
                            Whirlwind = 1680,
                            Bloodthirst = 23881,
                            RagingBlow = 85288,
                            WildStrike = 100130;

        #endregion Warrior

        #region Warlock

        internal const int DarkRegeneration = 108359,
                            HarvestLife = 108371,
                            HowlOfTerror = 5484,
                            MortalCoil = 6789,
                            Shadowfury = 30283,
                            SoulLink = 108415,
                            SacrificalPact = 108416,
                            DarkBargan = 110913,
                            BloodFear = 111397,
                            BurningRush = 11140,
                            UnboundWill = 108482,
                            GrimoureOfService = 108501,
                            GrimoireOfSacrifice = 108503,
                            ArchimondesVengeance = 108505,
                            KiljaedensCunning = 119049,
                            Agony = 980,
                            Banish = 710,
                            CommandDemon = 119898,
                            Corruption = 172,
                            CreateHealthstone = 6201,
                            CreateSoulwell = 29893,
                            CurseofEnfeeblement = 109466,
                            CurseofExhaustion = 18223,
                            CurseoftheElements = 1490,
                            DarkIntent = 109773,
                            DarkSoul = 77801,
                            DemonicCircleSummon = 48018,
                            DemonicCircleTeleport = 48020,
                            DrainLife = 689,
                            DrainSoul = 1120,
                            EnslaveDemon = 1098,
                            EyeofKilrogg = 126,
                            Fear = 5782,
                            FelFlame = 77799,
                            Haunt = 48181,
                            HealthFunnel = 755,
                            LifeTap = 1454,
                            ShadowBolt = 686,
                            RainofFire = 5740,
                            RitualofSummoning = 698,
                            SeedofCorruption = 27243,
                            SoulSwap = 86121,
                            Soulburn = 74434,
                            Soulshatter = 29858,
                            Soulstone = 20707,
                            SummonDoomguard = 18540,
                            SummonInfernal = 1122,
                            TwilightWard = 6229,
                            UnendingBreath = 5697,
                            UnendingResolve = 104773,
                            UnstableAffliction = 30108,
                            SummonFelhunter = 691,
                            SummonImp = 688,
                            SummonSuccubus = 712,
                            SummonVoidwalker = 697,
                            WarlockSymbiosis = 110505,
                            CarrionSwarm = 103967,
                            DarkSoulKnowledge = 113861,
                            DemonicGateway = 111771,
                            DemonicLeap = 109151,
                            HandofGuldan = 105174,
                            Hellfire = 1949,
                            Metamorphosis = 103958,
                            SoulFire = 6353,
                            ChaosBolt = 116858,
                            Conflagrate = 17962,
                            DarkSoulInstability = 113858,
                            EmberTap = 114635,
                            FireandBrimstone = 108683,
                            FlamesofXoroth = 120451,
                            Havoc = 80240,
                            Immolate = 348,
                            Incinerate = 29722,
                            Shadowburn = 17877;

        #endregion Warlock

        #region Mage

        internal const int PresenceOfMind = 12043,
                            Scorch = 2948,
                            IceFloes = 108839,
                            TemporalShield = 115610,
                            BlazingSpeed = 108843,
                            IceBarrier = 11426,
                            RingOfFrost = 113724,
                            IceWard = 111264,
                            Frostjaw = 102051,
                            GreaterInvisibility = 110959,
                            ColdSnap = 11958,
                            NetherTempest = 114923,
                            LivingBomb = 44457,
                            FrostBomb = 112948,
                            RuneOfPower = 116011,
                            IncantersWard = 1463,
                            ArcaneBrilliance = 1459,
                            ArcaneExplosion = 1449,
                            Blink = 1953,
                            Blizzard = 10,
                            Combustion = 11129,
                            ConeofCold = 120,
                            ConjureManaGem = 759,
                            ConjureRefreshment = 42955,
                            ConjureRefreshmentTable = 43987,
                            Counterspell = 2139,
                            DeepFreeze = 44572,
                            DragonsBreath = 31661,
                            Evocation = 12051,
                            Fireball = 133,
                            Flamestrike = 2120,
                            FrostArmor = 7302,
                            FrostNova = 122,
                            FrostfireBolt = 44614,
                            IceBlock = 45438,
                            IceLance = 30455,
                            FireBlast = 2136,
                            Invisibility = 66,
                            MageArmor = 6117,
                            MageBomb = 125430,
                            MirrorImage = 55342,
                            MoltenArmor = 30482,
                            Polymorph = 118,
                            Pyroblast = 11366,
                            RemoveCurse = 475,
                            SlowFall = 130,
                            Spellsteal = 30449,
                            TimeWarp = 80353,
                            PortalDalaran = 53142,
                            PortalOrgrimmar = 11417,
                            PortalShattrath = 35717,
                            PortalSilvermoon = 32267,
                            PortalStonard = 49361,
                            PortalThunderBluff = 11420,
                            PortalTolBarad = 88346,
                            PortalUndercity = 11418,
                            MageSymbiosis = 110499,
                            TeleportDalaran = 53140,
                            TeleportOrgrimmar = 3567,
                            TeleportShattrath = 35715,
                            TeleportSilvermoon = 32272,
                            TeleportStonard = 49358,
                            TeleportThunderBluff = 3566,
                            TeleportTolBarad = 88344,
                            TeleportUndercity = 3563,
                            AlterTime = 108978,
                            ArcaneBarrage = 44425,
                            ArcaneBlast = 30451,
                            ArcaneMissiles = 5143,
                            ArcanePower = 12042,
                            Slow = 31589,
                            Frostbolt = 116,
                            FrozenOrb = 84714,
                            IcyVeins = 12472,
                            SummonWaterElemental = 31687;

        #endregion Mage

        #region Rogue

        internal const int DeadlyThrow = 26679,
                            CombatReadiness = 74001,
                            LeechingPoison = 108211,
                            Preparation = 14185,
                            Shadowstep = 36554,
                            BurstOfSpeed = 108212,
                            ParalyticPoison = 108215,
                            ShurikenToss = 114014,
                            Ambush = 8676,
                            Backstab = 53,
                            Blind = 2094,
                            CheapShot = 1833,
                            CloakofShadows = 31224,
                            CrimsonTempest = 121411,
                            DisarmTrap = 1842,
                            Dismantle = 51722,
                            Distract = 1725,
                            Evasion = 5277,
                            Eviscerate = 2098,
                            ExposeArmor = 8647,
                            FanofKnives = 51723,
                            Feint = 1966,
                            Garrote = 703,
                            Gouge = 1776,
                            SinisterStrike = 1752,
                            Kick = 1766,
                            KidneyShot = 408,
                            PickLock = 1804,
                            PickPocket = 921,
                            Premeditation = 14183,
                            Recuperate = 73651,
                            Redirect = 73981,
                            Rupture = 1943,
                            Sap = 6770,
                            ShadowDance = 51713,
                            ShadowWalk = 114842,
                            Shiv = 5938,
                            ShroudofConcealment = 114018,
                            SliceandDice = 5171,
                            SmokeBomb = 76577,
                            Sprint = 2983,
                            Stealth = 1784,
                            RogueThrow = 121733,
                            TricksoftheTrade = 57934,
                            Vanish = 1856,
                            CripplingPoison = 3408,
                            DeadlyPoison = 2823,
                            MindNumbingPoison = 5761,
                            RogueSymbiosis = 110503,
                            WoundPoison = 8679,
                            Dispatch = 111240,
                            Envenom = 32645,
                            Mutilate = 1329,
                            ShadowBlades = 121471,
                            Vendetta = 79140,
                            AdrenalineRush = 13750,
                            BladeFlurry = 13877,
                            KillingSpree = 51690,
                            RevealingStrike = 84617;

        #endregion Rogue

        #region Hunter

        internal const int SilencingShot = 34490,
                            WyvernSting = 19386,
                            BindingShot = 109248,
                            Exhileration = 109304,
                            SpectOfTheIronHawk = 109260,
                            Fervor = 82726,
                            DireBeast = 120679,
                            AMurderOfCrows = 131894,
                            BlinkStrike = 130392,
                            LynxRush = 120697,
                            GlaiveToss = 117050,
                            Powershot = 109259,
                            Barrage = 120360,
                            ArcaneShot = 3044,
                            AspectoftheCheetah = 5118,
                            AspectoftheFox = 82661,
                            AspectoftheHawk = 13165,
                            AspectofthePack = 13159,
                            AutoShot = 75,
                            BeastLore = 1462,
                            BestialWrath = 19574,
                            Camouflage = 51753,
                            SteadyShot = 56641,
                            ConcussiveShot = 5116,
                            Deterrence = 19263,
                            Disengage = 781,
                            DismissPet = 2641,
                            DistractingShot = 20736,
                            EagleEye = 6197,
                            FeedPet = 6991,
                            FeignDeath = 5384,
                            Flare = 1543,
                            FocusFire = 82692,
                            HuntersMark = 1130,
                            Intimidation = 19577,
                            KillCommand = 34026,
                            KillShot = 53351,
                            MastersCall = 53271,
                            MendPet = 136,
                            Misdirection = 34477,
                            MultiShot = 2643,
                            RapidFire = 3045,
                            Readiness = 23989,
                            RevivePet = 982,
                            ScareBeast = 1513,
                            ScatterShot = 19503,
                            SerpentSting = 1978,
                            TameBeast = 1515,
                            TranquilizingShot = 19801,
                            TrapLauncher = 77769,
                            WidowVenom = 82654,
                            CallPet1 = 883,
                            CallPet2 = 83242,
                            CallPet3 = 83243,
                            CallPet4 = 83244,
                            CallPet5 = 83245,
                            ExplosiveTrap = 13813,
                            FreezingTrap = 1499,
                            IceTrap = 13809,
                            SnakeTrap = 34600,
                            HunterSymbiosis = 110497,
                            AimedShot = 19434,
                            ChimeraShot = 53209,
                            Stampede = 121818,
                            BlackArrow = 3674,
                            CobraShot = 77767,
                            ExplosiveShot = 53301;

        #endregion Hunter

        #region Paladin

        internal const int SpeedOfLight = 85499,
                            FistOfJustice = 105593,
                            Repentance = 20066,
                            EternalFlame = 114163,
                            SealofCommand = 105361,
                            SacredShield = 20925,
                            HandOfPurity = 114039,
                            HolyAvenger = 105809,
                            SanctifiedWrath = 53376,
                            HolyPrism = 114165,
                            LightsHammer = 114158,
                            ExecutionSentence = 114157,
                            PaladinSymbiosis = 110501,
                            AncestralSwiftness = 16188,
                            AvengingWrath = 31884,
                            BeaconofLight = 53563,
                            BlessingofKings = 20217,
                            BlessingofMight = 19740,
                            Cleanse = 4987,
                            CrusaderStrike = 35395,
                            Denounce = 2812,
                            DevotionAura = 31821,
                            DivineFavor = 31842,
                            DivineLight = 82326,
                            DivinePlea = 54428,
                            DivineProtection = 498,
                            DivinePurpose = 90174, //86172
                            DivineShield = 642,
                            FlashofLight = 19750,
                            Forbearance = 25771,
                            SelflessHealer = 114250,
                            GuardianofAncientKings = 86698,
                            HammerofJustice = 853,
                            HammerofWrath = 24275,
                            HandofFreedom = 1044,
                            HandofProtection = 1022,
                            HandofSacrifice = 6940,
                            HandofSalvation = 1038,
                            HolyLight = 635,
                            HolyRadiance = 82327,
                            HolyShock = 20473,
                            InfusionofLight = 54149,
                            Judgment = 20271,
                            LayonHands = 633,
                            LightofDawn = 85222,
                            Rebuke = 96231,
                            Reckoning = 62124,
                            Redemption = 7328,
                            RighteousFury = 25780,
                            SealofInsight = 20165,
                            SealofRighteousness = 20154,
                            SealofTruth = 31801,
                            TurnEvil = 10326,
                            WordofGlory = 85673,
                            ArdentDefender = 31850,
                            AvengersShield = 31935,
                            BlindingLight = 115750,
                            Consecration = 26573,
                            HammeroftheRighteous = 53595,
                            HolyWrath = 119072,
                            ShieldoftheRighteous = 53600,
                            DivineStorm = 53385,
                            Emancipate = 121783,
                            Exorcism = 879,
                            Inquisition = 84963,
                            SealofJustice = 20164,
                            TemplarsVerdict = 85256;

        #endregion Paladin
    }
}